/*
sort_double.c -- shows simple double sort using qsort
*/
#include <stdlib.h>
#include <stdio.h>

#define MAX 100

int doublecomparison(const void *v1, const void *v2);

int main(void)
{
	int i;
	double arr[MAX], arrsort[MAX];
/* Get random integers from the rand() function */
	srand(17);
	printf("RAND_MAX=%10d\n", RAND_MAX);            /* check operating system limit value */
	for(i=0;i<MAX;i++)
	{
		arr[i] = rand()/((double)RAND_MAX + 1); /* fill arr[,] with random doubles*/
		arrsort[i] = arr[i];
	}
	qsort(arrsort, MAX, sizeof(double), doublecomparison);
	for(i=0;i<MAX;i++)
	{
		printf("%10d  arr[%10.6f]  arrsort[%10.6f]\n", i, arr[i], arrsort[i]);
	}
	printf("\n\n");
	return(0);
}
int doublecomparison(const void *v1, const void *v2)
{
	const double *a1 = v1;
	const double *a2 = v2;
	if(*a1 > *a2)return -1;
	else if(*a1 == *a2)return 0;
	else return 1;
}
